<template>
  <v-container ref="catalog-container" class="catalog-container" fluid>
    <v-row>
      <v-col cols="2">
        <v-list>
          <v-list-group prepend-icon="mdi-currency-rub" value="true">
            <template v-slot:activator>
              <v-list-item-title>{{ $t('heading.filter-price') }}</v-list-item-title>
            </template>

            <v-list-item>
              <v-list-item-content class="pa-0">
                <v-row>
                  <v-col cols="6">
                    <v-text-field v-model="filter.price[0]" :label="$t('text.from')" clearable></v-text-field>
                  </v-col>
                  <v-col cols="6">
                    <v-text-field v-model="filter.price[1]" :label="$t('text.to')" clearable></v-text-field
                  ></v-col>
                </v-row>
              </v-list-item-content>
            </v-list-item>
          </v-list-group>
        </v-list>

        <categories-tree
          :categories="categories.tree"
          :category-slug="categorySlug"
          :selected-tree="selectedTree"
        ></categories-tree>
      </v-col>

      <v-col cols="10">
        <template v-if="$fetchState.pending">
          <div class="text-center mt-10">
            <v-progress-circular :size="96" color="light-blue" indeterminate></v-progress-circular>
          </div>
        </template>
        <template v-else>
          <template v-if="!productsTotal">
            <div class="headline" v-text="categorySelected.name"></div>
            <v-alert
              border="top"
              colored-border
              type="info"
              elevation="2"
              class="mt-5"
              v-text="$t('text.category-emptry')"
            ></v-alert>
          </template>
          <template v-else>
            <v-row>
              <template v-if="categorySelected">
                <v-col cols="8">
                  <div class="d-flex align-center">
                    <h1>
                      <v-icon v-if="categoryIcon" left color="pink" v-text="categoryIcon"></v-icon>
                      <span class="headline" v-text="categorySelected.name"></span>
                    </h1>

                    <v-chip v-if="productsTotal" color="lime" label class="mx-2 pl-1 pr-2">
                      <v-chip color="light-green" class="px-2 mr-1" label small>{{
                        productsTotal | formattedCost
                      }}</v-chip>
                      <span v-text="$tc('text.product-total', productsTotal)"></span>
                    </v-chip>

                    <v-chip v-if="filter.price[0]" color="lime" label class="mx-2 px-1 text-lowercase">
                      <span>{{ $t('text.price-range[0]') }}</span>
                      <v-chip color="light-green" class="px-1 ml-1" label small>
                        {{ filter.price[0] | formattedCost }} ₽
                      </v-chip>
                    </v-chip>
                  </div>
                </v-col>
                <v-col cols="4" class="d-flex justify-end">
                  <v-breadcrumbs v-if="breadcrumbs.length > 1" :items="breadcrumbs" class="pa-0"></v-breadcrumbs>
                </v-col>

                <v-divider></v-divider>
              </template>

              <v-col v-for="product in products" :key="`catalog-product-${product.id}`" cols="3" class="product">
                <v-card class="fill-height">
                  <v-row no-gutters>
                    <v-col cols="6" class="d-flex align-start">
                      <v-chip
                        v-if="product.brand"
                        label
                        small
                        color="lime lighten-3"
                        class="product__brand"
                        v-text="product.brand"
                      ></v-chip>
                    </v-col>
                    <v-col cols="6" class="text-right">
                      <v-chip label class="product__price subtitle-1 font-weight-medium">
                        <span>{{ product.price | formattedCost }}</span> ₽
                      </v-chip>
                    </v-col>
                  </v-row>
                  <nuxt-link :to="`${baseUrl}/${product.category}/${product.id}`">
                    <v-img :aspect-ratio="16 / 9" :src="product.images[0].big" contain class="product__img"> </v-img>
                  </nuxt-link>

                  <v-card-title class="product__title text-center">
                    <nuxt-link :to="`${baseUrl}/${product.category}/${product.id}`" v-text="product.name"></nuxt-link>
                  </v-card-title>

                  <!-- <v-list-item
                    nuxt
                    :to="`${baseUrl}/${product.category}/${product.id}`"
                    class="product__title mt-3 text-center"
                  >
                    <v-list-item-title v-text="product.name"></v-list-item-title>
                  </v-list-item> -->

                  <!-- <div class="product__subtitle px-4 mb-2 caption" v-text="product.full_name"></div> -->

                  <div v-if="Object.values(product.subproducts || []).length > 1" class="product__subproducts">
                    <nuxt-link
                      v-for="subproduct in Object.values(product.subproducts).slice(0, 4)"
                      :key="`catalog-subproduct-${subproduct.product_oasis_id}`"
                      :to="`${baseUrl}/${subproduct.category}/${subproduct.product_oasis_id}`"
                      class="product__subproducts-item pa-1 mr-3 d-flex"
                    >
                      <v-img :src="subproduct.image" class="ma-auto" contain></v-img>
                    </nuxt-link>
                  </div>
                </v-card>
              </v-col>
              <v-col v-if="pagesTotal > 1" cols="12">
                <v-pagination
                  :value="perPage"
                  :length="pagesTotal"
                  :total-visible="10"
                  @input="paginationInput"
                ></v-pagination>
              </v-col>
            </v-row>
          </template>
        </template>
      </v-col>
    </v-row>
  </v-container>
</template>

<script>
let Isotope

export default {
  async fetch() {
    const fieldset = 'full'
    const category = this.categorySlug
    const limit = this.productsLimit
    const offset = this.offset

    this.products = []

    try {
      this.products = await this.$api('v1').request('oasis/products', {
        params: { fieldset, category, limit, offset },
      })
    } catch (err) {
      console.error(err)
    }

    if (this.products.length) {
      try {
        const total = await this.$api('v1').request(`oasis/total?category=${category}`)
        this.productsTotal = total.result
      } catch (err) {
        console.error(err)
      }
    }
  },

  data: () => ({
    iso: null,
    active: [],
    products: [],
    productsTotal: 0,
    productsLimit: 20,
    filter: {
      price: ['', ''],
    },
  }),

  computed: {
    baseUrl() {
      return process.env.CATALOG_BASE_URL
    },

    categories() {
      return this.$store.state.catalog.categories
    },

    categorySlug() {
      return parseInt(this.$route.params.category) || 0
    },

    categorySelected() {
      return this.categories.flat.find(category => category.id === this.categorySlug)
    },

    categoryIcon() {
      const { icons } = this.$store.state.catalog
      return icons[this.categorySlug]
    },

    selectedTree() {
      const result = []
      const getCategory = id => this.categories.flat.find(category => category.id === parseInt(id)) || {}
      let category = getCategory(this.categorySlug)

      while (parseInt(category.parent_id || 0) !== 0) {
        result.push(category.id)
        category = getCategory(category.parent_id)
      }

      return result
    },

    breadcrumbs() {
      return this.categories.flat
        .filter(category => this.selectedTree.includes(category.id))
        .map(category => ({
          text: category.name,
          href: `${this.baseUrl}/${category.id}`,
          disabled: category.id === this.categorySlug,
        }))
    },

    pagesTotal() {
      return Math.floor(this.productsTotal / this.productsLimit)
    },

    perPage() {
      return parseInt(this.$route.query.page) || 1
    },

    offset() {
      return this.perPage * this.productsLimit
    },
  },

  watch: {
    '$route.query': '$fetch',

    /* async page(val) {
      const contRef = this.$refs['catalog-container']
      const url = `oasis/products/list?category=${this.categorySlug}?limit=${this.productsLimit}&offset=${this.offset}`

      this.$vuetify.goTo(contRef)
      this.products = await this.$axios.$get(url)
      this.offset = this.page * this.productsLimit
    },

    'filter.price'(val) {
      val.forEach((v, i) => {
        this.filter.price[i] = v.replace(/\D+/g, '')
      })

      const url = '/oasis/products'
      const { price } = this.filter

      if (timer) clearTimeout(timer)
      timer = setTimeout(async () => {
        this.products = []
        this.products = await this.$axios.$get(`${url}/list`, {
          category: this.categorySlug,
          limit: this.productsLimit,
          price_from: price[0],
          price_to: price[1],
        })

        const total = await this.$axios.$get(`${url}/total`, { category: this.categorySlug })
        this.productsTotal = total.result
      }, 1500)
    }, */
  },

  mounted() {
    // this.isotope()
  },

  methods: {
    paginationInput(page) {
      this.$router.replace({ query: { ...this.$route.query, page } })
    },

    isotope() {
      this.iso = new Isotope('.isotope', {
        itemSelector: '.isotope-item',
        percentPosition: true,
        /* masonry: {
          columnWidth: ".grid-sizer"
        } */
      })

      this.iso.layout()
    },
  },

  validate({ params, query, store }) {
    const { flat } = store.state.catalog.categories
    return flat.some(category => parseInt(category.id) === parseInt(params.category))
  },

  head() {
    const { APP_NAME } = process.env
    return {
      title: this.categorySelected.name,
      titleTemplate: `%s | ${APP_NAME}`,
      // meta: [{ hid: 'description', name: 'description', content: this.description }]
    }
  },
}
</script>

<style lang="scss" scoped>
.catalog-container {
  .product {
    position: relative;
    z-index: 0;
    transition: transform 0.3s;

    &__img {
      transition: transform 0.5s;
    }

    .v-card {
      position: relative;

      &::before {
        position: absolute;
        z-index: -1;
        bottom: 0;
        left: 0;
        width: 100%;
        height: 100%;
        background: linear-gradient(135deg, #d06383 0%, #c1e782 100%);
        border-radius: 40px;
        content: '';
        filter: blur(25px);
        opacity: 0;
        transform: translateY(30px) scale(0.9);
        transition: all 0.3s ease-in-out;
      }

      &:hover {
        &::before {
          opacity: 1;
        }

        .product__img {
          transform: translateY(-20px) scale(1.3);
        }
      }
    }

    &__title {
      display: block;
      padding: 1rem 4rem 1.5rem;
      font-size: 1rem;
      font-weight: 500;
      line-height: 1.2rem;
      word-break: normal;

      a {
        color: #212121;
      }
    }

    &__subtitle {
      line-height: 1rem;
    }

    &__brand {
      position: relative;
      z-index: 5;
    }

    &__price {
      position: relative;
      z-index: 5;
      background: linear-gradient(135deg, #ffe082 0%, #ff9800 100%);
      transition: transform 0.3s, background 0.2s;

      > span {
        font-family: $numerals-font-family;
      }
    }

    &__subproducts {
      position: absolute;
      z-index: 8;
      bottom: 0.5rem;
      left: -3rem;
      opacity: 0;
      transition: all 0.3s ease-in-out;

      &-item {
        display: block;
        width: 65px;
        height: 65px;
        border: solid 2px #fff;
        margin: 0 0 6px;
        background: #fff;
        border-radius: 5px;
        box-shadow: 0 0 8px -4px #000;
        transition: all 0.3s ease-in-out;

        &:hover {
          border-color: #ff9800;
          box-shadow: 0 0 14px -5px #000;
        }
      }
    }

    &:hover {
      z-index: 5;
      transform: scale3d(1.1, 1.1, 1.1);

      .product__price {
        transform: scale(1.2);
      }

      .product__subproducts {
        left: 0.5rem;
        opacity: 1;
      }
    }
  }
}
</style>
